<?php
// add your custom actions here. Don't forget to declare them by calling add_action() in watuprocustom_init()
class NamasteMojoActions {
	// verify instamojo payment on template_redirect
	// if error wp_die
	// if success insert the payment and redirect
	static function verify_payment() {
		global $wpdb, $user_ID;
		if(empty($_GET['namastemojo'])) return true;
		
		$options = get_option('namastemojo_options');
		
		if(!class_exists('Instamojo')) require NAMASTEMOJO_PATH."/lib/instamojo/instamojo.php";
		
		$api = new Instamojo($options['api_key'], $options['token']);		
		//print_r($_GET);
		try {
        $response = $api->paymentDetail($_GET['payment_id']);
       // print_r($response);

        if($response['status'] != 'Credit') wp_die("Payment status not verified");
        
        if(empty($response['custom_fields'])) wp_die("Custom fields missing!");
       
        // now figure out the item we pay for and its price
        $item_id = $item_type = '';
        foreach($response['custom_fields'] as $key => $field) {
        	  if($field['label'] == 'item_id') $item_id = $field['value'];
        	  if($field['label'] == 'item_type') $item_type = $field['value'];
        }
        
        if(empty($item_id)) wp_die("Item ID is missing");
		  if(empty($item_type)) wp_die("Item type is missing");
		  
		  // select item to check amount etc		
			if($item_type == 'course') {				
				$course = $wpdb->get_row($wpdb->prepare("SELECT * FROM {$wpdb->posts} WHERE ID=%d", $item_id));
				$fee = get_post_meta($course->ID, 'namaste_fee', true);				
				$target_url = get_permalink($course->ID);				
			}
			elseif($item_type == 'class') {
				// class signup
				$cls = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".NAMASTEPRO_CLASSES." WHERE id=%d", $item_id));
				$fee = $cls->price;
				$target_url = site_url();	
			}
			else {
				// shopping cart
				$cart = $wpdb->get_row($wpdb->prepare("SELECT * FROM " . NAMASTEPRO_SHOPCARTS . " WHERE id=%d", $item_id));
				$fee = NamastePROCart :: calculate_total($cart); 
				$target_url = site_url();	
			}
			
			// used coupon?
			$fee = apply_filters('namaste-coupon-applied', $fee);		
			
			if($fee > $response['amount']) wp_die("Paid less: the cost is $fee while the amount paid is $response[amount]");
			
			$currency = get_option('namaste_currency');
			
			if($currency != $response['currency']) wp_die("Wrong currency. Paid in $response[currency] while the requested currency is $currency."); 
			
			// make sure payment ID is unique and insert the payment
        $payment_id_exists = $wpdb->get_var($wpdb->prepare("SELECT paycode FROM {$wpdb->prefix}namaste_payments 
		   WHERE paycode=%s", $_GET['payment_id']));		   		   
			if(empty($payment_id_exists)) {
				$wpdb->query($wpdb->prepare("INSERT INTO {$wpdb->prefix}namaste_payments SET 
				course_id=%d, user_id=%s, date=CURDATE(), amount=%s, status='completed', paycode=%s, 
				paytype='instamojo', class_id=%d, cart_id=%d", 
				@$course->ID, $user_ID, $fee, $_GET['payment_id'], @$cls->id, @$cart->id));
				
				if($item_type == 'course') {
					// enroll accordingly to course settings 
					do_action('namaste-paid', $user_ID, $fee, "course", $course->ID);	
					$enroll_mode = get_post_meta($course->ID, 'namaste_enroll_mode', true);	
					if(!NamasteLMSStudentModel :: is_enrolled($user_ID, $course->ID))  {
						$_course = new NamasteLMSCourseModel();
						$status = ($enroll_mode == 'free') ? 'enrolled' : 'pending';				
						$_course->enroll($user_ID, $course->ID, $status);
					}
				}
				elseif($item_type == 'class') {
					// class payment
					do_action('namaste-paid', $user_ID, $fee, "class", $cls->id);			
					// echo "SIGNUP $user_ID in ".$cls->id;						
					NamastePROClass :: signup($user_ID, $cls->id);	
				}
				else {
					// shopping cart
					// shopping cart checkout
					do_action('namaste-paid', $user_ID, $fee, "cart", $cart->id);
					NamastePROCart :: checkout($item_id);
				}	
			} // 
			
			// figure out where to redirect				
			namaste_redirect($target_url);        
	   }
	   catch (Exception $e) {
	        wp_die('Error: ' . $e->getMessage());
	   }
	}
}