<?php
/*
Plugin Name: Namaste! LMS Integration for InstaMojo
Plugin URI: 
Description: Lets you process payments made through https://www.instamojo.com/
Author: Kiboko Labs
Version: 1.1
Author URI: http://calendarscripts.info/
License: GPLv2 or later
*/

define( 'NAMASTEMOJO_PATH', dirname( __FILE__ ) );
define( 'NAMASTEMOJO_RELATIVE_PATH', dirname( plugin_basename( __FILE__ )));
define( 'NAMASTEMOJO_URL', plugin_dir_url( __FILE__ ));

include(NAMASTEMOJO_PATH.'/controllers/shortcodes.php');
include(NAMASTEMOJO_PATH.'/controllers/actions.php');
include(NAMASTEMOJO_PATH.'/controllers/filters.php');

register_activation_hook( __FILE__, 'namastemojo_activate' );
add_action('init', 'namastemojo_init');

function namastemojo_activate() {
	// let's not use this for now and see how things work only with using sessions	
	global $user_ID, $wpdb;
	namastemojo_init();
		
	// create database tables or add DB fields
}

function namastemojo_init() {
	global $wpdb;
	if (!session_id()) @session_start();
	
	// typically you'll want to add at least jQuery
	wp_enqueue_script('jquery');
   
   // add custom admin menu entries if any
	add_action('namaste_lms_admin_menu', 'namastemojo_menu');
	
	// add custom shortcodes here. This will call the shortcode handler in controller/shortcodes.php
	add_shortcode('namastemojo-button', array('NamasteMojoShortcodes', 'button'));
		
	// add custom action handlers if any
	add_action('template_redirect', array('NamasteMojoActions', 'verify_payment'));
	
	add_action( 'wp_enqueue_scripts', 'namastemojo_css' );
	add_action( 'admin_enqueue_scripts', 'namastemojo_css' );
}

function namastemojo_css() {
	wp_register_style( 'namastemojo-css', NAMASTEMOJO_URL.'css/main.css?v=1');
	wp_enqueue_style( 'namastemojo-css' );
}

function namastemojo_menu() {
	add_submenu_page('namaste_options', 'InstaMojo Integration', 'InstaMojo Integration', 'manage_options', 'namastemojo_options', 'namastemojo_options');
}

// manage instamojo settings
function namastemojo_options() {
	if(!empty($_POST['ok'])) {
		$options = array();
		$options['api_key'] = $_POST['api_key'];
		$options['token'] = $_POST['token'];
		$options['button_text'] = $_POST['button_text'];
		$options['link'] = $_POST['link'];
		// names of the two custom field in the Instamojo which will serve us to pass the information about course and ID 
		$options['field_item_id'] = $_POST['field_item_id']; 
		$options['field_item_type'] = $_POST['field_item_type'];
		
		update_option('namastemojo_options', $options);
	}
	
	$options = get_option('namastemojo_options');
	
	include(NAMASTEMOJO_PATH."/views/options.html.php");
} // end options